<?php
// vim: foldmethod=marker
/**
 *  Flare_ActionForm.php
 *
 *  @author     Masaki Fujimoto
 *  @package    Flare
 *  @version    $Id: app.actionform.php,v 1.1 2006/08/22 15:52:26 fujimoto Exp $
 */

// {{{ Flare_ActionForm
/**
 *  ե९饹
 *
 *  @author     Masaki Fujimoto
 *  @package    Flare
 *  @access     public
 */
class Flare_ActionForm extends Ethna_ActionForm
{
    /**#@+
     *  @access private
     */

    /** @var    array   ե(ǥե) */
    var $form_template = array(
        'mail' => array(
            'name' => '᡼륢ɥ쥹',
            'custom' => 'checkMailaddress',
        ),
        'password' => array(
            'name' => 'ѥ',
            'form_type' => FORM_TYPE_PASSWORD,
        ),
        'name' => array(
            'name' => '̾',
        ),
        'alias' => array(
            'name' => 'ꥢ',
            'regexp' => '/^[0-9a-z]+$/',
            'min' => 4,
        ),
        'password_conf' => array(
            'name' => 'ѥ(ǧ)',
            'max' => 255,
            'form_type' => FORM_TYPE_PASSWORD,
            'type' => VAR_TYPE_STRING,
            'custom' => 'checkPassword',
        ),
        'type' => array(
            'name' => '',
            'form_type' => FORM_TYPE_SELECT,
            'type' => VAR_TYPE_INT,
            'custom' => 'checkAccountType',
            'select' => array('account', 'account_type'),
        ),
        'inout' => array(
            'name' => '󤬤',
            'regexp' => '/^\+?(\d+)$/',
        ),
        'ctime' => array(
            'name' => '',
        ),
        'account_id' => array(
            'name' => '',
            'form_type' => FORM_TYPE_SELECT,
            'select' => array('', 'account_id'),
        ),
        'tag' => array(
            'name' => '',
            'max' => 255,
            'type' => VAR_TYPE_STRING,
            'form_type' => FORM_TYPE_TEXT,
            'filter' => FILTER_HW,
        ),
    );

    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /**#@-*/

    /**
     *  ե͸ڤΥ顼Ԥ
     *
     *  @access public
     *  @param  string      $name   ե̾
     *  @param  int         $code   顼
     */
    function handleError($name, $code)
    {
        return parent::handleError($name, $code);
    }

    /**
     *  եƥץ졼Ȥꤹ
     *
     *  @access protected
     *  @param  array   $form_template  եͥƥץ졼
     *  @return array   եͥƥץ졼
     */
    function _setFormTemplate($form_template)
    {
        return parent::_setFormTemplate($form_template);
    }

    /**
     *  եꤹ
     *
     *  @access protected
     */
    function _setFormDef()
    {
        return parent::_setFormDef();
    }

	/**
	 *	å᥽å: ǧѥѥ
	 *
	 *	@access	public
	 *	@param	string	$name	ե̾
	 */
	function checkPassword($name)
	{
		if ($this->form_vars['password'] == "" || $this->form_vars[$name] == "") {
			return;
		}

		if ($this->form_vars['password'] == $this->form_vars[$name]) {
			return;
		}
		$this->ae->add($name, "{form}פޤ", E_FORM_CONFIRM);
	}

    function listAccountId()
    {
        $session =& $this->backend->getSession();
        $user_id = $session->get('user_id');

        $am = $this->backend->getManager('account');
        list($count, $list) = $am->getObjectList('account', array('user_id' => $user_id));

        $r = array();
        foreach ($list as $account) {
            $r[$account->get('id')] = array('name' => $account->get('name'));
        }

        return $r;
    }
}
// }}}
?>
