<?php
/**
 *	Flare_User.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.app_object.php,v 1.2 2006/03/07 16:23:18 fujimoto Exp $
 */
define('FLARE_USER_TYPE_NORMAL', 1);
define('FLARE_USER_TYPE_ADMIN', 2);

define('FLARE_USER_STATE_ACTIVE', 1);

/**
 *	Flare_UserManager
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_UserManager extends Ethna_AppManager
{
}

/**
 *	Flare_User
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_User extends Ethna_AppObject
{
    /**
     *  ץѥƥɽ̾
     *
     *  @access public
     */
    function getName($key)
    {
        return $this->get($key);
    }

    function set($key, $value)
    {
        if ($key == 'password') {
            $value = md5($value);
            return $this->prop[$key] = $value;
        } else {
            return parent::set($key, $value);
        }
    }

    /**
     *  桼ɲä
     *
     *  @access public
     */
    function add()
    {
        if (is_null($this->get('type'))) {
            $this->set('type', FLARE_USER_TYPE_NORMAL);
        }
        $this->set('state', FLARE_USER_STATE_ACTIVE);
        $this->set('ctime', strftime('%Y/%m/%d %H:%M:%S'));
        $this->set('hash', Ethna_Util::getRandom());

        return parent::add();
    }

    function auth($password, $lifetime = 0)
    {
        // ǧڽ
        if ($this->isValid() == false) {
            return Ethna::raiseNotice(null, E_GENERAL);
        }
        if (strcasecmp($this->get('password'), md5($password)) != 0) {
            return Ethna::raiseNotice(null, E_GENERAL);
        }

        // 
        $this->session->start($lifetime);
        $this->session->set('user_id', $this->getId());
        $this->session->set('user', $this->getNameObject());

        return 0;
    }
}
?>
