<?php
// vim: foldmethod=marker
/**
 *  Flare_ViewClass.php
 *
 *  @author     Masaki Fujimoto
 *  @package    Flare
 *  @version    $Id: app.viewclass.php,v 1.1 2006/08/22 15:52:26 fujimoto Exp $
 */

include_once('HTML/TagCloud.php');

// {{{ Flare_ViewClass
/**
 *  view饹
 *
 *  @author     Masaki Fujimoto
 *  @package    Flare
 *  @access     public
 */
class Flare_ViewClass extends Ethna_ViewClass
{
    /** @var    string  󥳡ǥ */
    var $encoding = "";

    /** @var    string  ϥ */
    var $type = "";

    function forward()
    {
        if ($this->encoding != "") {
            ob_start();
            parent::forward();
            $s = ob_get_contents();
            ob_end_clean();

            print mb_convert_encoding($s, $this->encoding);
        } else {
            parent::forward();
        }
    }

    function _setTagList()
    {
        // tag list
        $tm =& $this->backend->getManager('tag');
        $tag_list = $tm->getTagList();

        $tag_cloud = new HTML_TagCloud();
        foreach ($tag_list as $tag) {
            $url = smarty_function_url(array('action' => 'journal_tag', 'tag' => $tag['name']), $dummy);
            $tag_cloud->addElement($tag['name'], $url, $tag['rate'] * $tag['rate'], '');
        }
        $this->af->setAppNE('tag_cloud_all', $tag_cloud->buildALL());

        $tag_list = $tm->getTagList($this->session->get('user_id'));
        $tag_cloud = new HTML_TagCloud();
        foreach ($tag_list as $tag) {
            $dummy = null;
            $url = smarty_function_url(array('action' => 'journal_tag_user', 'tag' => $tag['name']), $dummy);
            $tag_cloud->addElement($tag['name'], $url, $tag['rate'] * $tag['rate'], '');
        }
        $this->af->setAppNE('tag_cloud', $tag_cloud->buildALL());
    }

    /**
     *  ͤꤹ
     *
     *  @access protected
     *  @param  object  Flare_Renderer  饪֥
     */
    function _setDefault(&$renderer)
    {
    }
}
// }}}
?>
