<?php
/**
 *	Journal/Add.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.action.php,v 1.8 2006/07/10 13:47:33 fujimoto Exp $
 */

/**
 *	journal_addեμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Form_JournalAdd extends Flare_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /** @var    array   ץꥱ󥪥֥(helper) */
    var $helper_app_object = array(
        'account' => null,
        'journal' => null,
        'tag' => null,
    );

    /** @var    array   ץꥱ󥪥֥(helper)Ѥʤե̾ */
    var $helper_skip_form = array(
        'id', 'user_id', 'mtime', 'type', 'hash',
    );

	/**
	 *	@access	private
	 *	@var	array	ե
	 */
	var	$form = array(
        'tag' => array(
        ),
        'account_id' => array(
            'type' => VAR_TYPE_INT,
        ),
        'inout' => array(
            'type' => VAR_TYPE_STRING,
        ),
        'journal_add' => array(
            'name' => 'ɲ',
            'form_type' => FORM_TYPE_SUBMIT,
        ),
	);
}

/**
 *	journal_addμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Action_JournalAdd extends Flare_ActionClass
{
	/**
	 *	journal_add
	 *
	 *	@access	public
	 *	@return	string		̾(ｪλʤnull, λʤfalse)
	 */
	function prepare()
	{
        if ($this->af->validate() > 0) {
            return 'index';
        }
		return null;
	}

	/**
	 *	journal_addμ
	 *
	 *	@access	public
	 *	@return	string	̾
	 */
	function perform()
	{
        $inout = $this->af->get('inout');
        if ($inout{0} == '+') {
            $inout = substr($inout, 1);
        } else {
            $inout = "-$inout";
        }

        $journal =& $this->backend->getObject('journal');
        $journal->importForm(OBJECT_IMPORT_IGNORE_NULL);
        $journal->set('inout', $inout);
        $journal->set('user_id', $this->session->get('user_id'));
        $journal->add();
        $journal_id = $journal->get('id');

        // 
        $tag = $this->af->get('tag');
        $tm =& $this->backend->getManager('tag');
        $tm->add($tag, $journal_id);

        $this->af->clear();
        $this->ae->add(null, 'ɲäʤ');

		return 'index';
	}
}
?>
