<?php
/**
 *	Journal/Tag/User.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.action.php,v 1.8 2006/07/10 13:47:33 fujimoto Exp $
 */

include_once('Flare_Journal.php');
include_once('Flare_Tag.php');
/**
 *	journal_tag_userեμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Form_JournalTagUser extends Flare_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /** @var    array   ץꥱ󥪥֥(helper) */
    var $helper_app_object = array();

    /** @var    array   ץꥱ󥪥֥(helper)Ѥʤե̾ */
    var $helper_skip_form = array();

	/**
	 *	@access	private
	 *	@var	array	ե
	 */
	var	$form = array(
        'tag' => array(
            'required' => true,
        ),
	);
}

/**
 *	journal_tag_userμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Action_JournalTagUser extends Flare_ActionClass
{
	/**
	 *	journal_tag_user
	 *
	 *	@access	public
	 *	@return	string		̾(ｪλʤnull, λʤfalse)
	 */
	function prepare()
	{
        if ($this->af->validate() > 0) {
            return 'index';
        }
		return null;
	}

	/**
	 *	journal_tag_userμ
	 *
	 *	@access	public
	 *	@return	string	̾
	 */
	function perform()
	{
        $jm =& $this->backend->getManager('journal');
        list($journal_sum, $journal_list) = $jm->getJournalList(
            $this->session->get('user_id'),
            '',
            '',
            '',
            $this->af->get('tag'),
            'journal.mtime',
            1,
            0,
            ''
        );
        $this->af->setApp('journal_list', $journal_list);
        $this->af->setApp('journal_sum', $journal_sum);

		return 'journal_tag_user';
	}
}
?>
