<?php
/**
 *	User/Config/Duplicate.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.action.php,v 1.8 2006/07/10 13:47:33 fujimoto Exp $
 */

/**
 *	user_config_duplicateեμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Form_UserConfigDuplicate extends Flare_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /** @var    array   ץꥱ󥪥֥(helper) */
    var $helper_app_object = array();

    /** @var    array   ץꥱ󥪥֥(helper)Ѥʤե̾ */
    var $helper_skip_form = array();

	/**
	 *	@access	private
	 *	@var	array	ե
	 */
	var	$form = array(
        'alias' => array(
            'required' => true,
            'max' => 255,
            'type' => VAR_TYPE_STRING,
        ),
	);
}

/**
 *	user_config_duplicateμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Action_UserConfigDuplicate extends Flare_ActionClass
{
	/**
	 *	user_config_duplicate
	 *
	 *	@access	public
	 *	@return	string		̾(ｪλʤnull, λʤfalse)
	 */
	function prepare()
	{
        if ($this->af->validate() > 0) {
            $this->af->setApp('error', $this->ae->getMessage('alias'));
            return 'user_config_duplicate';
        }
		return null;
	}

	/**
	 *	user_config_duplicateμ
	 *
	 *	@access	public
	 *	@return	string	̾
	 */
	function perform()
	{
        $current = $this->session->get('user');
        if ($this->af->get('alias') == $current['alias']) {
            $this->af->setApp('available', "same");
            return 'user_config_duplicate';
        }
        $user = $this->backend->getObject('user', 'alias', $this->af->get('alias'));
        $this->af->setApp('available', $user->isValid() ? "no" : "yes");

		return 'user_config_duplicate';
	}
}
?>
