<?php
/**
 *	User/Signup/Do.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.action.php,v 1.8 2006/07/10 13:47:33 fujimoto Exp $
 */

/**
 *	user_signup_doեμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Form_UserSignupDo extends Flare_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /** @var    array   ץꥱ󥪥֥(helper) */
    var $helper_app_object = array(
        'user' => null,
    );

    /** @var    array   ץꥱ󥪥֥(helper)Ѥʤե̾ */
    var $helper_skip_form = array('user_id', 'type', 'state', 'hash', 'ctime', 'mtime');

	/**
	 *	@access	private
	 *	@var	array	ե
	 */
	var	$form = array(
        'password_conf' => array(
            'required' => true,
        ),
        'signup' => array(
            'name'      => '󥢥å',
            'form_type' => FORM_TYPE_SUBMIT,
            'type'      => VAR_TYPE_STRING,
        ),
	);
}

/**
 *	user_signup_doμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Action_UserSignupDo extends Flare_ActionClass
{
    var $auth = false;
    
	/**
	 *	user_signup_do
	 *
	 *	@access	public
	 *	@return	string		̾(ｪλʤnull, λʤfalse)
	 */
	function prepare()
	{
        if ($this->af->validate() > 0) {
            return 'user_signup';
        }
		return null;
	}

	/**
	 *	user_signup_doμ
	 *
	 *	@access	public
	 *	@return	string	̾
	 */
	function perform()
	{
        // ʣå
        foreach (array('mail', 'alias') as $key) {
            $user =& $this->backend->getObject('user', $key, $this->af->get($key));
            if ($user->isValid()) {
                $this->ae->add($key, "Ϥ줿{form}ϴ˻ѤƤޤ");
                return 'user_signup';
            }
        }

        $user =& $this->backend->getObject('user');
        $user->importForm(OBJECT_IMPORT_IGNORE_NULL);
        $r = $user->add();
        if (Ethna::isError($r)) {
            if ($r->getCode() == E_APP_DUPENT) {
                $key = $r->getUserInfo(0);
                $this->ae->add($key, "Ϥ줿{form}ϴ˻ѤƤޤ");
            } else {
                $this->ae->add(null, "顼Ǥ", E_GENERAL);
            }
            return 'user_signup';
        }

        $location = sprintf('Location: %s', $this->config->get('url'));
        header($location);

		return null;
	}
}
?>
