<?php
/**
 *	Account/Add.php
 *
 *	@author		Masaki Fujimoto
 *	@package	Flare
 *	@version	$Id: skel.action.php,v 1.8 2006/07/10 13:47:33 fujimoto Exp $
 */

/**
 *	account_addեμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Form_AccountAdd extends Flare_ActionForm
{
    /** @var    bool    Хǡ˥ץ饰Ȥե饰 */
    var $use_validator_plugin = true;

    /** @var    array   ץꥱ󥪥֥(helper) */
    var $helper_app_object = array(
        'account' => null,
    );

    /** @var    array   ץꥱ󥪥֥(helper)Ѥʤե̾ */
    var $helper_skip_form = array('id', 'user_id', 'ctime', 'mtime', 'hash');

	/**
	 *	@access	private
	 *	@var	array	ե
	 */
	var	$form = array(
        'account_add' => array(
            'name' => 'ɲ',
            'type'=> VAR_TYPE_STRING,
            'form_type' => FORM_TYPE_SUBMIT,
        ),
	);
}

/**
 *	account_addμ
 *
 *	@author		Masaki Fujimoto
 *	@access		public
 *	@package	Flare
 */
class Flare_Action_AccountAdd extends Flare_ActionClass
{
	/**
	 *	account_add
	 *
	 *	@access	public
	 *	@return	string		̾(ｪλʤnull, λʤfalse)
	 */
	function prepare()
	{
        if ($this->af->validate() > 0) {
            return 'account';
        }
		return null;
	}

	/**
	 *	account_addμ
	 *
	 *	@access	public
	 *	@return	string	̾
	 */
	function perform()
	{
        $account =& $this->backend->getObject('account');
        $account->importForm(OBJECT_IMPORT_IGNORE_NULL);
        $account->set('user_id', $this->session->get('user_id'));
        $account->add();

        $this->af->set('type', '');
        $this->af->set('name', '');

		return 'account';
	}
}
?>
